VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "NemoX Tut 15 - Free 6DOF camera"
   ClientHeight    =   7320
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8355
   LinkTopic       =   "Form1"
   ScaleHeight     =   7320
   ScaleWidth      =   8355
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'========================================
' -NemoX Tut 15 - Free 6DOF camera
'========================================

'============================================
'
' YOU HAVE TO SETUP THE LATEST NEMOX ENGINE
' TO MAKE THIS TURORIAL RUN
'
' GET IT AT
' http://perso.wanadoo.fr/malakoff/NemoXsetup1.074.exe
'



'In this tutorial we will see how to use New
'and extensible NemoX camera model, the Nemo_Camera2
'class allow to have 6DOF view and FPS view, each rotation
'axis is customizable






'===========Prerequisities

Option Explicit

'The Main One is The NemoX renderer
Dim Nemo As NemoX

'we're gonna use a Nemo class for rendering a mesh or polygons
'we use cNemo_Mesh class

Dim WithEvents Mesh As cNemo_Mesh
Attribute Mesh.VB_VarHelpID = -1

'we will need a quick acces to very important and useful functions
Dim Tool As cNemo_Tools

'New in NemoX 1.74
'this will handle camera moves
'the new camera class support Mouse rotation
' and Freelook (6DOF style)
'===============NEW CAMERA SYSTEM=======
'
'
'============================
Dim KAMERA As cNemo_Camera2

'this will handle for keyboard input state
Dim KEY As cNemo_Input



'===FOR SKY and Lens Flare====
'the sky object
Dim Sky As cNemo_SkyBox


Dim LENS As cNemo_LensFlare

'some constant for player speed
'Check at Sub GetKey()
Private Const RotationSpeed = 1 / (2 * 3.14) '1 degree step in radian

Private Const MoveSpeed = 2

'Entry point for our project
Private Sub Form_Load()

    Me.Show
    Me.Refresh

    'call the initializer sub
    Call InitEngine

    'make geometry
    Call BuilGeometry

    'call the main game Loop
    Call gameLoop

End Sub

'we build our mesh here

Sub BuilGeometry()

  Dim I As Long

    'adding a plane surface for a simple floor$

    'first off very important we pass a texture to the meshbuilder
    Mesh.Add_Texture (App.Path + "\roche.JPG")          '0
    Mesh.Add_Texture (App.Path + "\pierres.JPG")          '1
    Mesh.Add_Texture (App.Path + "\pillar.jpg")          '2
    
    '

    'Add flooor surface here
    Mesh.Add_WallFloor Tool.Vector(-5000, -1, -5000), Tool.Vector(5000, -1, 5000), 10, 10, 0

    'Just add some details at scene

    'Feel free to add more geometry details
    For I = 1 To 5
        Mesh.Add_Cilynder Tool.Vector(450 - I * 450 - 50, 10, -500 + 1500), 50, 490, 8, 2

        Mesh.Add_Cilynder Tool.Vector(450 - I * 450 - 50, 10, -1035 + 1500), 50, 490, 8, 2


    Mesh.Add_Box Vector(450 - I * 450 - 50 - 50, 490, -500 + 1500), Vector(450 - I * 450 - 50 + 50, 510, -1035 + 1500), 1, 1, 1, 1, 0, 0, 0.2, 2


    Next I
    
    'add walls
    Mesh.Add_Box Vector(550, 0, 0), Vector(600, 450, -600), 1, 1, 1, 1, 0, 0, 1, 1
    
    Mesh.Add_Box Vector(550, 0, 600), Vector(600, 450, 0), 1, 1, 1, 1, 0, 0, 1, 1
    

    Mesh.Set_CullMode D3DCULL_NONE
    '========IMPORTANT========
    'then we build our mesh
    Mesh.BuilDMesh
    
    
    
    
    '================THESE CODE BELOW IS FOR EYE CANDY EFFECTS==
      Set Sky = New cNemo_SkyBox
        Sky.Init_SkyBox
        
        Sky.Add_SkyBOX NEMO_SKY_LEFT, App.Path + "\powderpeak\powderpeak_lf.jpg"
        Sky.Add_SkyBOX NEMO_SKY_RIGHT, App.Path + "\powderpeak\powderpeak_rt.jpg"
        Sky.Add_SkyBOX NEMO_SKY_BACK, App.Path + "\powderpeak\powderpeak_bk.jpg"
        Sky.Add_SkyBOX NEMO_SKY_FRONT, App.Path + "\powderpeak\powderpeak_ft.jpg"
        Sky.Add_SkyBOX NEMO_SKY_DOWN, App.Path + "\powderpeak\powderpeak_dn.jpg"
        Sky.Add_SkyBOX NEMO_SKY_TOP, App.Path + "\powderpeak\powderpeak_up.jpg"
        
        Sky.Set_Scale 9000, 9000, 9000
        
        
        
        
        '============NEW CODE========
        ' setting up the Lensflare
        '===========================
        
        'allocate memory for our Lensflare class
        Set LENS = New cNemo_LensFlare
        
        
        'set our SunGlow textureFile,Position, and size
        LENS.Add_SunTEX App.Path + "\flare\mainlight.tga", Tool.Vector(-400, 5100, 800), 5500
        
        'configurate our cameraLensburningout color default=white &HFFFFFFFF
        LENS.Set_SunburningEffectColor 255, 255, 255
        LENS.Set_SunburningScreen False 'dactivate burning screen out effect
        
        
        'specify that we wil use a static position for our lenslare
        'this allow to simultate Ray of lens from any Static lightSource
        'In this demo we will use a static source
        
        
        'uncomment the above lign to set the lens flare at a static
        'position
        'LENS.Set_LensPositionStatus STATIC_SOURCE
        
        'activate randomizer
        Randomize Timer
        
        'we add 6 Lens Spark.....TextureFile,index,size,position,Color,SpecularColor
        'TextureFile =any TGA,BMP,JPG file
        'index       =the Index for the lensSpark
        'size        =the size of our spark
        'position    =the position the sun pos is 100, middle distance=50
        'Color       =main Color for the spark
        'highlight   =color for the outter of the circle
        
        'use random color=RGBA(Rnd, Rnd, Rnd, .4)
        
        
        'we add 14 flares textures
        LENS.Add_Lens App.Path + "\flare\far1.tga", 0, 25, 130, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)

        
        LENS.Add_Lens App.Path + "\flare\Flare1.tga", 1, 20, 50, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        LENS.Add_Lens App.Path + "\flare\Flare2.tga", 2, 17, 46, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        LENS.Add_Lens App.Path + "\flare\Flare3.tga", 3, 13, 41, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        LENS.Add_Lens App.Path + "\flare\Flare4.tga", 4, 10, 25, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        LENS.Add_Lens App.Path + "\flare\Flare5.tga", 5, 9, 20, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        LENS.Add_Lens App.Path + "\flare\Flare6.tga", 6, 5, 0, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        
        LENS.Add_Lens App.Path + "\flare\Flare7.tga", 7, 4, -14, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        LENS.Add_Lens App.Path + "\flare\Flare8.tga", 8, 3, -20, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        LENS.Add_Lens App.Path + "\flare\Flare9.tga", 9, 5, -22, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        
        LENS.Add_Lens App.Path + "\flare\Flare10.tga", 10, 2, -24, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        LENS.Add_Lens App.Path + "\flare\Flare11.tga", 11, 1, -32, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        LENS.Add_Lens App.Path + "\flare\Flare12.tga", 12, 0.8, -34, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
        
        LENS.Add_Lens App.Path + "\flare\Flare13.tga", 13, 1.4, -50, RGBA(Rnd, Rnd, Rnd, 0.4), RGBA(Rnd, Rnd, Rnd, 0.4)
      
      'this next line allows to specify the blending mode
      LENS.Set_LenflareBlend FLARES_BLENDMODE, D3DBLEND_DESTALPHA, D3DBLEND_DESTALPHA
      'make sun animation
      LENS.Set_SunAnimation True
      LENS.Set_SunAnimationSpeed 1

   

End Sub

'we will used that sub for the engine initialization

Sub InitEngine()

  'first thing allocate memory for the main Object

    Set Nemo = New NemoX

    Set Tool = New cNemo_Tools

    'allocate memory for our meshbuilder
    Set Mesh = New cNemo_Mesh

    '====New code======

   
    Set KAMERA = New cNemo_Camera2

    'end new code

    '.......MEMORY ALLOCATION....
    Set KEY = New cNemo_Input

    'we use this method
    'now we allow the user to choose options
    '32/16 bit backbuffer

    'for this demo Windowed mode is recommanded
    If Not (Nemo.INIT_ShowDeviceDLG(Form1.hWnd)) Then
        End 'terminate here if error
    End If

    'Nemo.Initialize Me.hWnd

    'set the back clearcolor
    Nemo.BackBuffer_ClearCOLOR = RGB(80, 80, 80) 'Gray

    'set some parameters 'near far  FOVangle,Aspect
    KAMERA.Set_ViewFrustum 5, 16000, 3.14 / 4, 1.01
    
    'Set Projection type we use here Perpective Left Hand
    KAMERA.Set_CameraProjectionType PT_PERSPECTIVE_LH

    'set our camera position
    KAMERA.Set_Position Vector(0, 50, -50)    'Starting Position
   
    'we specify 6 degrees of freedom camera style
    'note: the default style is First person Shooter
    KAMERA.Set_CameraStyle FREE_6DOF
    
    
    
End Sub

'this sub is the main loop for a game or 3d apllication
Sub gameLoop()

  'loop untill player press 'ESCAPE'
   Nemo.Set_CullMode D3DCULL_NONE

    Nemo.Set_EngineRenderState D3DRS_ZENABLE, 1
    Nemo.Set_light True
    Nemo.Set_EngineSpecularEnable True

    Do

        '=====Keyboard handler sub
        Call GetKey
        DoEvents

        'start the 3d renderer
        Nemo.Begin3D
        '===============ADD game rendering mrthod here


        'draw skybox environnment
        Sky.RenderSky
        
        
        'draw our ground here
        Mesh.Render
        
        
        'add lensflare effect
        LENS.Render
        
        


        'show the FPS at pixel(5,10) color White
        Nemo.Draw_Text "FPS:" + Str(Nemo.Framesperseconde), 5, 10, &HFFFFFFFF

        Nemo.End3D
        'end the 3d renderer

        'check the player keyPressed
    Loop Until KEY.Get_KeyBoardKeyPressed(NEMO_KEY_ESCAPE)

    Call EndGame

End Sub

'----------------------------------------
'Name: GetKey
'----------------------------------------
Sub GetKey()

  'just move Forward

    If KEY.Get_KeyBoardKeyPressed(NEMO_KEY_UP) Then _
       KAMERA.Move_Forward 1 * MoveSpeed

    'fast Forward
    If KEY.Get_KeyBoardKeyPressed(NEMO_KEY_RCONTROL) Then _
       KAMERA.Move_Forward 4 * MoveSpeed

    'just move BackWard
    If KEY.Get_KeyBoardKeyPressed(NEMO_KEY_DOWN) Then _
       KAMERA.Move_Backward 1 * MoveSpeed
       
       
    '============NEW CODE============'
    'we use mouse arcball system
    'to manage camera rotation
    '
    '
    'KAMERA.RotateByMouse mousepseed,invertMousePitching,recenterMouse Position
    '
    
    'we use default value and we do not recenter mouse after each
    'rotation and mouse moves
    '====!!! when recenter the mouse position
    '====!!! there is a lil bug that will be fixed soon==
    KAMERA.RotateByMouse 0.001, False, False
    
    
    'do not forget to actualize camera state
    'very important for object frustum visibility
    'testing
    
    'we check sphere collision before
    HandleCollision
    KAMERA.Update
    

   

End Sub


Sub HandleCollision()
  'if destination position intersect with polygons
  'just recall last camera position
  If Mesh.CheckCollision(KAMERA.Get_Position) Then _
  KAMERA.Set_Position KAMERA.Get_LastPosition
End Sub

Sub EndGame()

  'end of the demo

    Set KEY = Nothing
    Set KAMERA = Nothing
    Set Mesh = Nothing

    Nemo.Free  'free resources used by the engine
    Set Nemo = Nothing
    End

End Sub

Private Sub Form_Unload(Cancel As Integer)

    EndGame

End Sub

